Loading...
Searching...
No Matches
Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure > Class Template Reference

A generic class which tabulates all thermodynamic properties of a given component. More...

`#include <TabulatedComponent.hpp>`

## Public Types

using | Scalar = ScalarT

## Static Public Member Functions

static void | init (Scalar tempMin, Scalar tempMax, unsigned nTemp, Scalar pressMin, Scalar pressMax, unsigned nPress)
| Initialize the tables.
static std::string_view | name ()
| A human readable name for the component.
static Scalar | molarMass ()
| The molar mass in of the component.
static Scalar | criticalTemperature ()
| Returns the critical temperature in of the component.
static Scalar | criticalPressure ()
| Returns the critical pressure in of the component.
static Scalar | acentricFactor ()
| Returns the acentric factor of the component.
static Scalar | criticalVolume ()
| Returns the critical volume in of the component.
static Scalar | tripleTemperature ()
| Returns the temperature in at the component's triple point.
static Scalar | triplePressure ()
| Returns the pressure in at the component's triple point.
template<class Evaluation>
static Evaluation | vaporPressure (const Evaluation &temperature)
| The vapor pressure in of the component at a given temperature.
template<class Evaluation>
static Evaluation | gasEnthalpy (const Evaluation &temperature, const Evaluation &pressure)
| Specific enthalpy of the gas .
template<class Evaluation>
static Evaluation | liquidEnthalpy (const Evaluation &temperature, const Evaluation &pressure)
| Specific enthalpy of the liquid .
template<class Evaluation>
static Evaluation | gasHeatCapacity (const Evaluation &temperature, const Evaluation &pressure)
| Specific isobaric heat capacity of the gas .
template<class Evaluation>
static Evaluation | liquidHeatCapacity (const Evaluation &temperature, const Evaluation &pressure)
| Specific isobaric heat capacity of the liquid .
template<class Evaluation>
static Evaluation | gasInternalEnergy (const Evaluation &temperature, const Evaluation &pressure)
| Specific internal energy of the gas .
template<class Evaluation>
static Evaluation | liquidInternalEnergy (const Evaluation &temperature, const Evaluation &pressure)
| Specific internal energy of the liquid .
template<class Evaluation>
static Evaluation | gasPressure (const Evaluation &temperature, Scalar density)
| The pressure of gas in at a given density and temperature.
template<class Evaluation>
static Evaluation | liquidPressure (const Evaluation &temperature, Scalar density)
| The pressure of liquid in at a given density and temperature.
static bool | gasIsCompressible ()
| Returns true iff the gas phase is assumed to be compressible.
static bool | liquidIsCompressible ()
| Returns true iff the liquid phase is assumed to be compressible.
static bool | gasIsIdeal ()
| Returns true iff the gas phase is assumed to be ideal.
template<class Evaluation>
static Evaluation | gasDensity (const Evaluation &temperature, const Evaluation &pressure)
| The density of gas at a given pressure and temperature .
template<class Evaluation>
static Evaluation | liquidDensity (const Evaluation &temperature, const Evaluation &pressure)
| The density of liquid at a given pressure and temperature .
template<class Evaluation>
static Evaluation | gasViscosity (const Evaluation &temperature, const Evaluation &pressure)
| The dynamic viscosity of gas.
template<class Evaluation>
static Evaluation | liquidViscosity (const Evaluation &temperature, const Evaluation &pressure)
| The dynamic viscosity of liquid.
template<class Evaluation>
static Evaluation | gasThermalConductivity (const Evaluation &temperature, const Evaluation &pressure)
| The thermal conductivity of gaseous water .
template<class Evaluation>
static Evaluation | liquidThermalConductivity (const Evaluation &temperature, const Evaluation &pressure)
| The thermal conductivity of liquid water .

## Static Public Attributes

static constexpr bool | isTabulated = true

## Detailed Description

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
class Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >

A generic class which tabulates all thermodynamic properties of a given component.

At the moment, this class can only handle the sub-critical fluids since it tabulates along the vapor pressure curve.

Template Parameters

  Scalar | The type used for scalar values
  RawComponent | The component which ought to be tabulated
  useVaporPressure | If true, tabulate all quantities along the vapor pressure curve, if false use the pressure range [p_min, p_max]

## Member Function Documentation

## gasDensity()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::gasDensity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The density of gas at a given pressure and temperature .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasEnthalpy()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::gasEnthalpy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific enthalpy of the gas .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasHeatCapacity()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::gasHeatCapacity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific isobaric heat capacity of the gas .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasInternalEnergy()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::gasInternalEnergy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific internal energy of the gas .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasPressure()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::gasPressure | ( | const Evaluation & | temperature,
|  | Scalar | density )

inline static

The pressure of gas in at a given density and temperature.

Parameters

  temperature | temperature of component in
  density | density of component in

## gasThermalConductivity()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::gasThermalConductivity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The thermal conductivity of gaseous water .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasViscosity()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::gasViscosity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The dynamic viscosity of gas.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## init()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>

void Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::init | ( | Scalar | tempMin,
|  | Scalar | tempMax,
|  | unsigned | nTemp,
|  | Scalar | pressMin,
|  | Scalar | pressMax,
|  | unsigned | nPress )

inline static

Initialize the tables.

Parameters

  tempMin | The minimum of the temperature range in
  tempMax | The maximum of the temperature range in
  nTemp | The number of entries/steps within the temperature range
  pressMin | The minimum of the pressure range in
  pressMax | The maximum of the pressure range in
  nPress | The number of entries/steps within the pressure range

## liquidDensity()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::liquidDensity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The density of liquid at a given pressure and temperature .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidEnthalpy()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::liquidEnthalpy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific enthalpy of the liquid .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidHeatCapacity()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::liquidHeatCapacity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific isobaric heat capacity of the liquid .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidInternalEnergy()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::liquidInternalEnergy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific internal energy of the liquid .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidPressure()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::liquidPressure | ( | const Evaluation & | temperature,
|  | Scalar | density )

inline static

The pressure of liquid in at a given density and temperature.

Parameters

  temperature | temperature of component in
  density | density of component in

## liquidThermalConductivity()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::liquidThermalConductivity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The thermal conductivity of liquid water .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidViscosity()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::liquidViscosity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The dynamic viscosity of liquid.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## vaporPressure()

template<class ScalarT, class RawComponent, bool useVaporPressure = true>
template<class Evaluation>

Evaluation Opm::TabulatedComponent< ScalarT, RawComponent, useVaporPressure >::vaporPressure | ( | const Evaluation & | temperature | ) |

inline static

The vapor pressure in of the component at a given temperature.

Parameters

  temperature | temperature of component

The documentation for this class was generated from the following file:

- opm/material/components/TabulatedComponent.hpp